<template>
  <div id="edit-Category">
    <section>
      <input
        type="text"
        v-model="localCategory.categoryName"
        class="name-input"
      />
    </section>
    <section>
      <img :src="this.localCategory.icons" v-if="this.oldImg" />
      <img
        :src="this.localCategory.image.dataUrl"
        v-if="this.localCategory.hasImage"
      />
    </section>
    <section>
      <image-uploader
        :preview="false"
        :className="[
          'fileinput',
          { 'fileinput--loaded': localCategory.hasImage }
        ]"
        capture="environment"
        :debug="1"
        doNotResize="gif"
        :autoRotate="true"
        outputFormat="verbose"
        @input="setImage"
      >
        <label for="fileInput" slot="upload-label">
          <figure>
            <svg
              xmlns="http://www.w3.org/2000/svg"
              width="32"
              height="32"
              viewBox="0 0 32 32"
            >
              <path
                class="path1"
                d="M9.5 19c0 3.59 2.91 6.5 6.5 6.5s6.5-2.91 6.5-6.5-2.91-6.5-6.5-6.5-6.5 2.91-6.5 6.5zM30 8h-7c-0.5-2-1-4-3-4h-8c-2 0-2.5 2-3 4h-7c-1.1 0-2 0.9-2 2v18c0 1.1 0.9 2 2 2h28c1.1 0 2-0.9 2-2v-18c0-1.1-0.9-2-2-2zM16 27.875c-4.902 0-8.875-3.973-8.875-8.875s3.973-8.875 8.875-8.875c4.902 0 8.875 3.973 8.875 8.875s-3.973 8.875-8.875 8.875zM30 14h-4v-2h4v2z"
              />
            </svg>
          </figure>
          <span class="upload-caption">{{
            localCategory.hasImage ? 'Replace' : 'Click to upload'
          }}</span>
        </label>
      </image-uploader>
    </section>

    <section class="buttons">
      <v-btn
        small
        color="orange"
        v-on:click="cancelcategory()"
        class="cancel-edit"
        >cancel</v-btn
      >
      <v-btn
        small
        color="green"
        v-on:click="SaveChangedDetails()"
        class="SaveChangesButton"
        >save</v-btn
      >
    </section>
  </div>
</template>

<script>
import ImageUploader from 'vue-image-upload-resize'

export default {
  name: 'EditcategoryDetails',
  components: {
    ImageUploader
  },
  props: {
    category: {
      propType: Object,
      required: true
    }
  },

  data() {
    return {
      localCategory: {},
      oldImg: true
    }
  },

  mounted() {},
  watch: {
    category: {
      immediate: true,
      handler: function() {
        this.localCategory = JSON.parse(JSON.stringify(this.category))
      }
    }
  },

  methods: {
    async SaveChangedDetails() {
      this.$emit('save-new-details-event', this.localCategory)
    },

    setImage: function(output) {
      this.oldImg = false
      this.localCategory.hasImage = true
      this.localCategory.image = output
    },

    cancelcategory: function() {
      this.$emit('cancel-edit-category-details-event')
    }
  }
}
</script>
<style scoped>
#category_details {
  display: flex;
  flex-direction: column;
  justify-content: space-around;
}
.buttons {
  display: flex;

  justify-content: space-around;
}
</style>
